#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "popaccdlg.h"
#include "global.h"
#include "popretdlg.h"
#include "qspop3ver.h"

USERES("QSPOP3.res");
USEFORM("PopAccDlg.cpp", PopAcctDlg);
USEFORM("PopPassDlg.cpp", PassDlg);
USEFORM("PopProfDlg.cpp", AccProfDlg);
USEFORM("PopRetDlg.cpp", PopRetrDlg);
USEFORM("PrintDlg.cpp", PrintForm);
USEFORM("HelpDlgs.cpp", HelpDlg);
USEUNIT("QSpop3Ver.cpp");
USEUNIT("FileMan.cpp");
USEUNIT("Global.cpp");
USEUNIT("Mixmaster.cpp");
USEFORM("MixmastDlg.cpp", MixForm);
USEUNIT("HeadMan.cpp");
USEFORM("View.cpp", ViewDlg);
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport)  void __fastcall GetPop3Mail(TForm *MainForm,
   HWND AppHandle, bool UseDialog);
extern "C" __declspec(dllexport) char* __fastcall GetPop3Name();
extern "C" __declspec(dllexport) char* __fastcall GetPop3Version();
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
char* __fastcall GetPop3Name()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPop3Version()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
void __fastcall GetPop3Mail(TForm *MainForm, HWND AppHandle, bool UseDialog)
{
   Application->Handle = AppHandle;
   if (!UseDialog)
   {
      TStringList *accts = new TStringList();
      accts->SetText((char*)MainForm->Perform(WM_DATREQUEST,GetDatData,(LPARAM)PopAccounts.c_str()));
      // use just the PopRetrDlg--remove unchecked from accts
      int i=0; while (i<accts->Count)
      {
         if (accts->Strings[i].LowerCase().Pos("checked=1")==0)
             accts->Delete(i); else i++;
      }
      if (accts->Count)
      {
         PopRetrieveMail(accts,MainForm,MainForm);
         delete accts;
         return;
      }
      delete accts;
   }
   // no active accounts, fall through if get here,
   PopAcctDlg = new TPopAcctDlg(MainForm);
   CenterDialog(PopAcctDlg,MainForm);
   PopAcctDlg->accts->SetText((char*)MainForm->Perform(WM_DATREQUEST,GetDatData,(LPARAM)PopAccounts.c_str()));
   PopAcctDlg->SyncAccts();
   PopAcctDlg->ShowModal();
   if (PopAcctDlg->ModalResult!=mrCancel)
   {
      // send revised account list back to main app
      PopAcctDlg->accts->Insert(0,PopAccounts);
      MainForm->Perform(WM_DATREQUEST,PutDatData,(LPARAM)PopAcctDlg->accts->Text.c_str());
   }
   delete PopAcctDlg;
}
//---------------------------------------------------------------------------
